unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, BoldHandle, BoldUMLModelLink, BoldUMLXMILink, BoldAbstractModel,
  BoldModel, BoldHandles, BoldSubscription, BoldSystemHandle,
  BoldRootedHandles, BoldExpressionHandle, StdCtrls, BoldEdit, Grids,
  BoldGrid, BoldAbstractListHandle, BoldCursorHandle, BoldListHandle,
  BoldLabel, BoldVariableHandle, BoldListBox, BoldDerivedHandle, BoldElements,
  BoldReferenceHandle;

type
  TfrmMain = class(TForm)
    BoldSystemHandle: TBoldSystemHandle;
    BoldSystemTypeInfoHandle: TBoldSystemTypeInfoHandle;
    BoldModel: TBoldModel;
    BoldUMLXMILink: TBoldUMLXMILink;
    behMeal: TBoldExpressionHandle;
    BoldEdit1: TBoldEdit;
    BoldGrid1: TBoldGrid;
    blhIngredients: TBoldListHandle;
    bvhSelectedIngredientTypes: TBoldVariableHandle;
    BoldLabel1: TBoldLabel;
    blhIngredientTypes: TBoldListHandle;
    blbAvailableIngredients: TBoldListBox;
    blbSelectedIngredients: TBoldListBox;
    bchSelectedIngredientTypes: TBoldCursorHandle;
    btnAddIngredients: TButton;
    Label1: TLabel;
    Label2: TLabel;
    bdhMeal: TBoldDerivedHandle;
    brhIngredientType: TBoldReferenceHandle;
    btnEditIngredientType: TButton;
    BoldEdit2: TBoldEdit;
    BoldEdit3: TBoldEdit;
    BoldEdit4: TBoldEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure btnAddIngredientsClick(Sender: TObject);
    procedure blbSelectedIngredientsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure bdhMealDeriveAndSubscribe(Sender: TComponent;
      RootValue: TBoldElement; ResultElement: TBoldIndirectElement;
      Subscriber: TBoldSubscriber);
    procedure btnEditIngredientTypeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses BusinessClasses;

{$R *.dfm}

procedure TfrmMain.FormCreate(Sender: TObject);
var
  it: TIngredientType;
begin
  TMeal.Create(nil).Name := 'Lunch';

  it := TIngredientType.Create(nil);
  it.Name := 'Potato';
  it.EnergyDensity :=921/0.202;

  it := TIngredientType.Create(nil);
  it.Name := 'Tomato';
  it.EnergyDensity :=108/0.123;

  it :=TIngredientType.Create(nil);
  it.Name := 'Cheddar Cheese';
  it.EnergyDensity :=  883/0.052
end;

procedure TfrmMain.btnAddIngredientsClick(Sender: TObject);
var
  Ing: TIngredient;
begin
  bchSelectedIngredientTypes.First;
  while bchSelectedIngredientTypes.CurrentElement <> nil do
  begin
    Ing := TIngredient.Create(nil);
    Ing.ingredientType := bchSelectedIngredientTypes.CurrentBoldObject as TIngredientType;
    (behMeal.Value as TMeal).ingredient.Add(Ing);
    if bchSelectedIngredientTypes.HasNext then
      bchSelectedIngredientTypes.Next
    else break;
  end;

end;

procedure TfrmMain.blbSelectedIngredientsKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key = VK_DELETE then
    (bvhSelectedIngredientTypes.Value as TIngredientTypeList).Remove(
      blbSelectedIngredients.CurrentBoldObject);
end;

procedure TfrmMain.bdhMealDeriveAndSubscribe(Sender: TComponent;
  RootValue: TBoldElement; ResultElement: TBoldIndirectElement;
  Subscriber: TBoldSubscriber);
begin
  RootValue.EvaluateAndSubscribeToExpression(
    'Meal.AllInstances->first',
    Subscriber,
    ResultElement);
end;

procedure TfrmMain.btnEditIngredientTypeClick(Sender: TObject);
begin
  brhIngredientType.Value := blhIngredientTypes.CurrentElement;
end;

end.
